# coding: utf-8

# flake8: noqa

"""
    Instana REST API documentation

    Searching for answers and best pratices? Check our [IBM Instana Community](https://community.ibm.com/community/user/aiops/communities/community-home?CommunityKey=58f324a3-3104-41be-9510-5b7c413cc48f).  ## Overview The Instana REST API provides programmatic access to the Instana platform. It can be used to retrieve data available through the Instana UI Dashboard -- metrics, events, traces, etc -- and also to automate configuration tasks such as user management.  ### Navigating the API documentation The API endpoints are grouped by product area and functionality. This generally maps to how our UI Dashboard is organized, hopefully making it easier to locate which endpoints you'd use to fetch the data you see visualized in our UI. The [UI sections](https://www.ibm.com/docs/en/instana-observability/current?topic=working-user-interface#navigation-menu) include: - Websites & Mobile Apps - Applications - Infrastructure - Synthetic Monitoring - Events - Automation - Service Levels - Settings - etc  ### Rate Limiting A rate limit is applied to API usage. Up to 5,000 calls per hour can be made. How many remaining calls can be made and when this call limit resets, can inspected via three headers that are part of the responses of the API server.  - **X-RateLimit-Limit:** Shows the maximum number of calls that may be executed per hour. - **X-RateLimit-Remaining:** How many calls may still be executed within the current hour. - **X-RateLimit-Reset:** Time when the remaining calls will be reset to the limit. For compatibility reasons with other rate limited APIs, this date is not the date in milliseconds, but instead in seconds since 1970-01-01T00:00:00+00:00.  ### Further Reading We provide additional documentation for our REST API in our [product documentation](https://www.ibm.com/docs/en/instana-observability/current?topic=apis-web-rest-api). Here you'll also find some common queries for retrieving data and configuring Instana.  ## Getting Started with the REST API  ### API base URL The base URL for an specific instance of Instana can be determined using the tenant and unit information. - `base`: This is the base URL of a tenant unit, e.g. `https://test-example.instana.io`. This is the same URL that is used to access the Instana user interface. - `apiToken`: Requests against the Instana API require valid API tokens. An initial API token can be generated via the Instana user interface. Any additional API tokens can be generated via the API itself.  ### Curl Example Here is an Example to use the REST API with Curl. First lets get all the available metrics with possible aggregations with a GET call.  ```bash curl --request GET \\   --url https://test-instana.instana.io/api/application-monitoring/catalog/metrics \\   --header 'authorization: apiToken xxxxxxxxxxxxxxxx' ```  Next we can get every call grouped by the endpoint name that has an error count greater then zero. As a metric we could get the mean error rate for example.  ```bash curl --request POST \\   --url https://test-instana.instana.io/api/application-monitoring/analyze/call-groups \\   --header 'authorization: apiToken xxxxxxxxxxxxxxxx' \\   --header 'content-type: application/json' \\   --data '{   \"group\":{       \"groupbyTag\":\"endpoint.name\"   },   \"tagFilters\":[    {     \"name\":\"call.error.count\",     \"value\":\"0\",     \"operator\":\"GREATER_THAN\"    }   ],   \"metrics\":[    {     \"metric\":\"errors\",     \"aggregation\":\"MEAN\"    }   ]   }' ```  ### Generating REST API clients  The API is specified using the [OpenAPI v3](https://github.com/OAI/OpenAPI-Specification) (previously known as Swagger) format. You can download the current specification at our [GitHub API documentation](https://instana.github.io/openapi/openapi.yaml).  OpenAPI tries to solve the issue of ever-evolving APIs and clients lagging behind. Please make sure that you always use the latest version of the generator, as a number of improvements are regularly made. To generate a client library for your language, you can use the [OpenAPI client generators](https://github.com/OpenAPITools/openapi-generator).  #### Go For example, to generate a client library for Go to interact with our backend, you can use the following script; mind replacing the values of the `UNIT_NAME` and `TENANT_NAME` environment variables using those for your tenant unit:  ```bash #!/bin/bash  ### This script assumes you have the `java` and `wget` commands on the path  export UNIT_NAME='myunit' # for example: prod export TENANT_NAME='mytenant' # for example: awesomecompany  //Download the generator to your current working directory: wget https://repo1.maven.org/maven2/org/openapitools/openapi-generator-cli/4.3.1/openapi-generator-cli-4.3.1.jar -O openapi-generator-cli.jar --server-variables \"tenant=${TENANT_NAME},unit=${UNIT_NAME}\"  //generate a client library that you can vendor into your repository java -jar openapi-generator-cli.jar generate -i https://instana.github.io/openapi/openapi.yaml -g go \\     -o pkg/instana/openapi \\     --skip-validate-spec  //(optional) format the Go code according to the Go code standard gofmt -s -w pkg/instana/openapi ```  The generated clients contain comprehensive READMEs, and you can start right away using the client from the example above:  ```go import instana \"./pkg/instana/openapi\"  // readTags will read all available application monitoring tags along with their type and category func readTags() {  configuration := instana.NewConfiguration()  configuration.Host = \"tenant-unit.instana.io\"  configuration.BasePath = \"https://tenant-unit.instana.io\"   client := instana.NewAPIClient(configuration)  auth := context.WithValue(context.Background(), instana.ContextAPIKey, instana.APIKey{   Key:    apiKey,   Prefix: \"apiToken\",  })   tags, _, err := client.ApplicationCatalogApi.GetApplicationTagCatalog(auth)  if err != nil {   fmt.Fatalf(\"Error calling the API, aborting.\")  }   for _, tag := range tags {   fmt.Printf(\"%s (%s): %s\\n\", tag.Category, tag.Type, tag.Name)  } } ```  #### Java Follow the instructions provided in the official documentation from [OpenAPI Tools](https://github.com/OpenAPITools) to download the [openapi-generator-cli.jar](https://github.com/OpenAPITools/openapi-generator?tab=readme-ov-file#13---download-jar).  Depending on your environment, use one of the following java http client implementations which will create a valid client for our OpenAPI specification: ``` //Nativ Java HTTP Client java -jar openapi-generator-cli.jar generate -i https://instana.github.io/openapi/openapi.yaml -g java -o pkg/instana/openapi --skip-validate-spec  -p dateLibrary=java8 --library native  //Spring WebClient java -jar openapi-generator-cli.jar generate -i https://instana.github.io/openapi/openapi.yaml -g java -o pkg/instana/openapi --skip-validate-spec  -p dateLibrary=java8,hideGenerationTimestamp=true --library webclient  //Spring RestTemplate java -jar openapi-generator-cli.jar generate -i https://instana.github.io/openapi/openapi.yaml -g java -o pkg/instana/openapi --skip-validate-spec  -p dateLibrary=java8,hideGenerationTimestamp=true --library resttemplate  ``` 

    The version of the OpenAPI document: 1.291.1002
    Contact: support@instana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.0.0"

# import apis into sdk package
from instana_client.api.api_token_api import APITokenApi
from instana_client.api.action_catalog_api import ActionCatalogApi
from instana_client.api.action_history_api import ActionHistoryApi
from instana_client.api.apdex_report_api import ApdexReportApi
from instana_client.api.apdex_settings_api import ApdexSettingsApi
from instana_client.api.application_alert_configuration_api import ApplicationAlertConfigurationApi
from instana_client.api.application_analyze_api import ApplicationAnalyzeApi
from instana_client.api.application_catalog_api import ApplicationCatalogApi
from instana_client.api.application_metrics_api import ApplicationMetricsApi
from instana_client.api.application_resources_api import ApplicationResourcesApi
from instana_client.api.application_settings_api import ApplicationSettingsApi
from instana_client.api.application_topology_api import ApplicationTopologyApi
from instana_client.api.audit_log_api import AuditLogApi
from instana_client.api.authentication_api import AuthenticationApi
from instana_client.api.business_monitoring_api import BusinessMonitoringApi
from instana_client.api.custom_dashboards_api import CustomDashboardsApi
from instana_client.api.event_settings_api import EventSettingsApi
from instana_client.api.events_api import EventsApi
from instana_client.api.global_application_alert_configuration_api import GlobalApplicationAlertConfigurationApi
from instana_client.api.groups_api import GroupsApi
from instana_client.api.health_api import HealthApi
from instana_client.api.host_agent_api import HostAgentApi
from instana_client.api.infrastructure_alert_configuration_api import InfrastructureAlertConfigurationApi
from instana_client.api.infrastructure_analyze_api import InfrastructureAnalyzeApi
from instana_client.api.infrastructure_catalog_api import InfrastructureCatalogApi
from instana_client.api.infrastructure_metrics_api import InfrastructureMetricsApi
from instana_client.api.infrastructure_resources_api import InfrastructureResourcesApi
from instana_client.api.infrastructure_topology_api import InfrastructureTopologyApi
from instana_client.api.log_alert_configuration_api import LogAlertConfigurationApi
from instana_client.api.maintenance_configuration_api import MaintenanceConfigurationApi
from instana_client.api.mobile_app_analyze_api import MobileAppAnalyzeApi
from instana_client.api.mobile_app_catalog_api import MobileAppCatalogApi
from instana_client.api.mobile_app_configuration_api import MobileAppConfigurationApi
from instana_client.api.mobile_app_metrics_api import MobileAppMetricsApi
from instana_client.api.policies_api import PoliciesApi
from instana_client.api.releases_api import ReleasesApi
from instana_client.api.sli_report_api import SLIReportApi
from instana_client.api.sli_settings_api import SLISettingsApi
from instana_client.api.service_levels_alert_configuration_api import ServiceLevelsAlertConfigurationApi
from instana_client.api.service_levels_objective_slo_configurations_api import ServiceLevelsObjectiveSLOConfigurationsApi
from instana_client.api.service_levels_objective_slo_report_api import ServiceLevelsObjectiveSLOReportApi
from instana_client.api.session_settings_api import SessionSettingsApi
from instana_client.api.synthetic_alert_configuration_api import SyntheticAlertConfigurationApi
from instana_client.api.synthetic_calls_api import SyntheticCallsApi
from instana_client.api.synthetic_catalog_api import SyntheticCatalogApi
from instana_client.api.synthetic_metrics_api import SyntheticMetricsApi
from instana_client.api.synthetic_settings_api import SyntheticSettingsApi
from instana_client.api.synthetic_test_playback_results_api import SyntheticTestPlaybackResultsApi
from instana_client.api.usage_api import UsageApi
from instana_client.api.user_api import UserApi
from instana_client.api.website_analyze_api import WebsiteAnalyzeApi
from instana_client.api.website_catalog_api import WebsiteCatalogApi
from instana_client.api.website_configuration_api import WebsiteConfigurationApi
from instana_client.api.website_metrics_api import WebsiteMetricsApi

# import ApiClient
from instana_client.api_response import ApiResponse
from instana_client.api_client import ApiClient
from instana_client.configuration import Configuration
from instana_client.exceptions import OpenApiException
from instana_client.exceptions import ApiTypeError
from instana_client.exceptions import ApiValueError
from instana_client.exceptions import ApiKeyError
from instana_client.exceptions import ApiAttributeError
from instana_client.exceptions import ApiException

# import models into sdk package
from instana_client.models.abstract_integration import AbstractIntegration
from instana_client.models.abstract_rule import AbstractRule
from instana_client.models.access_log_entry import AccessLogEntry
from instana_client.models.access_log_response import AccessLogResponse
from instana_client.models.access_rule import AccessRule
from instana_client.models.action import Action
from instana_client.models.action_configuration import ActionConfiguration
from instana_client.models.action_instance import ActionInstance
from instana_client.models.action_instance_metadata_entry import ActionInstanceMetadataEntry
from instana_client.models.action_instance_parameter import ActionInstanceParameter
from instana_client.models.action_instance_request import ActionInstanceRequest
from instana_client.models.action_instance_request_parameters import ActionInstanceRequestParameters
from instana_client.models.action_match import ActionMatch
from instana_client.models.action_search_space import ActionSearchSpace
from instana_client.models.adaptive_baseline import AdaptiveBaseline
from instana_client.models.adaptive_threshold_rule import AdaptiveThresholdRule
from instana_client.models.adjusted_timeframe import AdjustedTimeframe
from instana_client.models.agent_configuration_update import AgentConfigurationUpdate
from instana_client.models.alerting_configuration import AlertingConfiguration
from instana_client.models.alerting_configuration_with_last_updated import AlertingConfigurationWithLastUpdated
from instana_client.models.alerting_time_window import AlertingTimeWindow
from instana_client.models.apdex_configuration import ApdexConfiguration
from instana_client.models.apdex_configuration_input import ApdexConfigurationInput
from instana_client.models.apdex_entity import ApdexEntity
from instana_client.models.apdex_report import ApdexReport
from instana_client.models.api_create_group import ApiCreateGroup
from instana_client.models.api_group import ApiGroup
from instana_client.models.api_member import ApiMember
from instana_client.models.api_permission_set import ApiPermissionSet
from instana_client.models.api_restricted_application_filter import ApiRestrictedApplicationFilter
from instana_client.models.api_token import ApiToken
from instana_client.models.app_data_metric_configuration import AppDataMetricConfiguration
from instana_client.models.application import Application
from instana_client.models.application_alert_config import ApplicationAlertConfig
from instana_client.models.application_alert_config_with_metadata import ApplicationAlertConfigWithMetadata
from instana_client.models.application_alert_rule import ApplicationAlertRule
from instana_client.models.application_apdex_entity import ApplicationApdexEntity
from instana_client.models.application_config import ApplicationConfig
from instana_client.models.application_event_result import ApplicationEventResult
from instana_client.models.application_item import ApplicationItem
from instana_client.models.application_metric_result import ApplicationMetricResult
from instana_client.models.application_node import ApplicationNode
from instana_client.models.application_result import ApplicationResult
from instana_client.models.application_scope import ApplicationScope
from instana_client.models.application_scope_with_metadata import ApplicationScopeWithMetadata
from instana_client.models.application_sli_entity import ApplicationSliEntity
from instana_client.models.application_slo_entity import ApplicationSloEntity
from instana_client.models.application_time_threshold import ApplicationTimeThreshold
from instana_client.models.audit_log_entry import AuditLogEntry
from instana_client.models.audit_log_ui_response import AuditLogUiResponse
from instana_client.models.author import Author
from instana_client.models.availability_blueprint_indicator import AvailabilityBlueprintIndicator
from instana_client.models.availability_sli_entity import AvailabilitySliEntity
from instana_client.models.available_metrics import AvailableMetrics
from instana_client.models.available_plugins import AvailablePlugins
from instana_client.models.backend_trace_reference import BackendTraceReference
from instana_client.models.binary_operator_dto import BinaryOperatorDTO
from instana_client.models.browser_script_configuration import BrowserScriptConfiguration
from instana_client.models.built_in_event_specification import BuiltInEventSpecification
from instana_client.models.built_in_event_specification_with_last_updated import BuiltInEventSpecificationWithLastUpdated
from instana_client.models.business_activity import BusinessActivity
from instana_client.models.business_perspective_config import BusinessPerspectiveConfig
from instana_client.models.call_groups_item import CallGroupsItem
from instana_client.models.call_groups_result import CallGroupsResult
from instana_client.models.call_relation import CallRelation
from instana_client.models.change_summary import ChangeSummary
from instana_client.models.cloudfoundry_physical_context import CloudfoundryPhysicalContext
from instana_client.models.condition import Condition
from instana_client.models.config_version import ConfigVersion
from instana_client.models.crash_mobile_app_alert_rule import CrashMobileAppAlertRule
from instana_client.models.cursor_paginated_business_activity_item import CursorPaginatedBusinessActivityItem
from instana_client.models.cursor_pagination import CursorPagination
from instana_client.models.cursor_pagination_infra_explore_cursor import CursorPaginationInfraExploreCursor
from instana_client.models.custom_blueprint_indicator import CustomBlueprintIndicator
from instana_client.models.custom_dashboard import CustomDashboard
from instana_client.models.custom_dashboard_preview import CustomDashboardPreview
from instana_client.models.custom_email_subject_prefix import CustomEmailSubjectPrefix
from instana_client.models.custom_event_mobile_app_alert_rule import CustomEventMobileAppAlertRule
from instana_client.models.custom_event_specification import CustomEventSpecification
from instana_client.models.custom_event_specification_with_last_updated import CustomEventSpecificationWithLastUpdated
from instana_client.models.custom_event_website_alert_rule import CustomEventWebsiteAlertRule
from instana_client.models.custom_payload_configuration import CustomPayloadConfiguration
from instana_client.models.custom_payload_field import CustomPayloadField
from instana_client.models.custom_payload_with_last_updated import CustomPayloadWithLastUpdated
from instana_client.models.dns_action_configuration import DNSActionConfiguration
from instana_client.models.dns_action_filter_query_time import DNSActionFilterQueryTime
from instana_client.models.dns_action_filter_target_value import DNSActionFilterTargetValue
from instana_client.models.dashboard_api_token import DashboardApiToken
from instana_client.models.database_integration import DatabaseIntegration
from instana_client.models.deprecated_tag_filter import DeprecatedTagFilter
from instana_client.models.duration import Duration
from instana_client.models.dynamic_field import DynamicField
from instana_client.models.dynamic_field_value import DynamicFieldValue
from instana_client.models.dynamic_parameter import DynamicParameter
from instana_client.models.edit_user import EditUser
from instana_client.models.email_integration import EmailIntegration
from instana_client.models.empty_configuration import EmptyConfiguration
from instana_client.models.endpoint import Endpoint
from instana_client.models.endpoint_config import EndpointConfig
from instana_client.models.endpoint_event_result import EndpointEventResult
from instana_client.models.endpoint_item import EndpointItem
from instana_client.models.endpoint_metric_result import EndpointMetricResult
from instana_client.models.endpoint_node import EndpointNode
from instana_client.models.endpoint_result import EndpointResult
from instana_client.models.endpoint_simple import EndpointSimple
from instana_client.models.entity_count_rule import EntityCountRule
from instana_client.models.entity_count_verification_rule import EntityCountVerificationRule
from instana_client.models.entity_health_info import EntityHealthInfo
from instana_client.models.entity_id import EntityId
from instana_client.models.entity_verification_rule import EntityVerificationRule
from instana_client.models.error_budget_alert_rule import ErrorBudgetAlertRule
from instana_client.models.errors_application_alert_rule import ErrorsApplicationAlertRule
from instana_client.models.event import Event
from instana_client.models.event_filtering_configuration import EventFilteringConfiguration
from instana_client.models.event_result import EventResult
from instana_client.models.event_specification_info import EventSpecificationInfo
from instana_client.models.extended_service import ExtendedService
from instana_client.models.failure_synthetic_alert_rule import FailureSyntheticAlertRule
from instana_client.models.fixed_http_path_segment_matching_rule import FixedHttpPathSegmentMatchingRule
from instana_client.models.fixed_time_window import FixedTimeWindow
from instana_client.models.full_trace import FullTrace
from instana_client.models.generic_infra_alert_rule import GenericInfraAlertRule
from instana_client.models.geo_location_configuration import GeoLocationConfiguration
from instana_client.models.geo_mapping_rule import GeoMappingRule
from instana_client.models.geo_subdivision import GeoSubdivision
from instana_client.models.get_activities import GetActivities
from instana_client.models.get_application_metrics import GetApplicationMetrics
from instana_client.models.get_applications import GetApplications
from instana_client.models.get_available_metrics_query import GetAvailableMetricsQuery
from instana_client.models.get_available_plugins_query import GetAvailablePluginsQuery
from instana_client.models.get_call_groups import GetCallGroups
from instana_client.models.get_combined_metrics import GetCombinedMetrics
from instana_client.models.get_dynamic_parameter_values import GetDynamicParameterValues
from instana_client.models.get_endpoints import GetEndpoints
from instana_client.models.get_infrastructure_groups_query import GetInfrastructureGroupsQuery
from instana_client.models.get_infrastructure_query import GetInfrastructureQuery
from instana_client.models.get_metrics_result import GetMetricsResult
from instana_client.models.get_mobile_app_beacon_groups import GetMobileAppBeaconGroups
from instana_client.models.get_mobile_app_beacons import GetMobileAppBeacons
from instana_client.models.get_mobile_app_metrics import GetMobileAppMetrics
from instana_client.models.get_mobile_app_metrics_v2 import GetMobileAppMetricsV2
from instana_client.models.get_payload_keys_result import GetPayloadKeysResult
from instana_client.models.get_services import GetServices
from instana_client.models.get_snapshots_query import GetSnapshotsQuery
from instana_client.models.get_test_result import GetTestResult
from instana_client.models.get_test_result_base import GetTestResultBase
from instana_client.models.get_test_result_list import GetTestResultList
from instana_client.models.get_test_summary_result import GetTestSummaryResult
from instana_client.models.get_trace_download_result_item import GetTraceDownloadResultItem
from instana_client.models.get_trace_groups import GetTraceGroups
from instana_client.models.get_traces import GetTraces
from instana_client.models.get_website_beacon_groups import GetWebsiteBeaconGroups
from instana_client.models.get_website_beacons import GetWebsiteBeacons
from instana_client.models.get_website_metrics import GetWebsiteMetrics
from instana_client.models.get_website_metrics_v2 import GetWebsiteMetricsV2
from instana_client.models.global_application_alert_config_with_metadata import GlobalApplicationAlertConfigWithMetadata
from instana_client.models.global_applications_alert_config import GlobalApplicationsAlertConfig
from instana_client.models.google_chat_integration import GoogleChatIntegration
from instana_client.models.graph_edge import GraphEdge
from instana_client.models.graph_node import GraphNode
from instana_client.models.group import Group
from instana_client.models.group_by_tag import GroupByTag
from instana_client.models.group_mapping import GroupMapping
from instana_client.models.health_state import HealthState
from instana_client.models.historic_baseline import HistoricBaseline
from instana_client.models.host_availability_rule import HostAvailabilityRule
from instana_client.models.http_action_configuration import HttpActionConfiguration
from instana_client.models.http_endpoint_config import HttpEndpointConfig
from instana_client.models.http_endpoint_rule import HttpEndpointRule
from instana_client.models.http_path_segment_matching_rule import HttpPathSegmentMatchingRule
from instana_client.models.http_script_configuration import HttpScriptConfiguration
from instana_client.models.hyper_param import HyperParam
from instana_client.models.identity_provider_patch import IdentityProviderPatch
from instana_client.models.infra_alert_config import InfraAlertConfig
from instana_client.models.infra_alert_config_with_metadata import InfraAlertConfigWithMetadata
from instana_client.models.infra_alert_rule import InfraAlertRule
from instana_client.models.infra_event_result import InfraEventResult
from instana_client.models.infra_metric_configuration import InfraMetricConfiguration
from instana_client.models.infra_time_threshold import InfraTimeThreshold
from instana_client.models.infrastructure_entities_result import InfrastructureEntitiesResult
from instana_client.models.infrastructure_group import InfrastructureGroup
from instana_client.models.infrastructure_groups_result import InfrastructureGroupsResult
from instana_client.models.infrastructure_item import InfrastructureItem
from instana_client.models.infrastructure_metric_result import InfrastructureMetricResult
from instana_client.models.instana_version_info import InstanaVersionInfo
from instana_client.models.integration_overview import IntegrationOverview
from instana_client.models.invitation import Invitation
from instana_client.models.invitation_response import InvitationResponse
from instana_client.models.invitation_result import InvitationResult
from instana_client.models.ip_masking_configuration import IpMaskingConfiguration
from instana_client.models.js_stack_trace_line import JsStackTraceLine
from instana_client.models.kubernetes_physical_context import KubernetesPhysicalContext
from instana_client.models.latency_blueprint_indicator import LatencyBlueprintIndicator
from instana_client.models.location_status import LocationStatus
from instana_client.models.log_alert_config import LogAlertConfig
from instana_client.models.log_alert_config_with_metadata import LogAlertConfigWithMetadata
from instana_client.models.log_alert_rule import LogAlertRule
from instana_client.models.log_count_alert_rule import LogCountAlertRule
from instana_client.models.log_entry_actor import LogEntryActor
from instana_client.models.log_event_result import LogEventResult
from instana_client.models.log_time_threshold import LogTimeThreshold
from instana_client.models.logs_application_alert_rule import LogsApplicationAlertRule
from instana_client.models.maintenance_config import MaintenanceConfig
from instana_client.models.maintenance_config_scheduling import MaintenanceConfigScheduling
from instana_client.models.maintenance_config_v2 import MaintenanceConfigV2
from instana_client.models.maintenance_config_v2_with_state_and_occurrence import MaintenanceConfigV2WithStateAndOccurrence
from instana_client.models.maintenance_config_with_last_updated import MaintenanceConfigWithLastUpdated
from instana_client.models.maintenance_window import MaintenanceWindow
from instana_client.models.manual_alerting_channel_configuration import ManualAlertingChannelConfiguration
from instana_client.models.manual_close_info import ManualCloseInfo
from instana_client.models.manual_service_config import ManualServiceConfig
from instana_client.models.match_all_http_path_segment_matching_rule import MatchAllHttpPathSegmentMatchingRule
from instana_client.models.match_expression_dto import MatchExpressionDTO
from instana_client.models.meta_data import MetaData
from instana_client.models.metric_api_result import MetricAPIResult
from instana_client.models.metric_config import MetricConfig
from instana_client.models.metric_configuration import MetricConfiguration
from instana_client.models.metric_description import MetricDescription
from instana_client.models.metric_instance import MetricInstance
from instana_client.models.metric_item import MetricItem
from instana_client.models.metric_metadata import MetricMetadata
from instana_client.models.metric_pattern import MetricPattern
from instana_client.models.metrics_result import MetricsResult
from instana_client.models.metrics_result_item import MetricsResultItem
from instana_client.models.metrics_test_result_item import MetricsTestResultItem
from instana_client.models.mobile_app import MobileApp
from instana_client.models.mobile_app_alert_config import MobileAppAlertConfig
from instana_client.models.mobile_app_alert_rule import MobileAppAlertRule
from instana_client.models.mobile_app_beacon_groups_item import MobileAppBeaconGroupsItem
from instana_client.models.mobile_app_beacon_groups_result import MobileAppBeaconGroupsResult
from instana_client.models.mobile_app_beacon_result import MobileAppBeaconResult
from instana_client.models.mobile_app_beacon_tag_group import MobileAppBeaconTagGroup
from instana_client.models.mobile_app_beacons_item import MobileAppBeaconsItem
from instana_client.models.mobile_app_event_result import MobileAppEventResult
from instana_client.models.mobile_app_metric_result import MobileAppMetricResult
from instana_client.models.mobile_app_monitoring_beacon import MobileAppMonitoringBeacon
from instana_client.models.mobile_app_monitoring_metric_description import MobileAppMonitoringMetricDescription
from instana_client.models.mobile_app_monitoring_metrics_configuration import MobileAppMonitoringMetricsConfiguration
from instana_client.models.mobile_app_time_threshold import MobileAppTimeThreshold
from instana_client.models.model_field import ModelField
from instana_client.models.monitoring_state import MonitoringState
from instana_client.models.multiple_scripts_configuration import MultipleScriptsConfiguration
from instana_client.models.new_application_config import NewApplicationConfig
from instana_client.models.new_business_perspective_config import NewBusinessPerspectiveConfig
from instana_client.models.new_manual_service_config import NewManualServiceConfig
from instana_client.models.occurrence import Occurrence
from instana_client.models.office365_integration import Office365Integration
from instana_client.models.one_time_maintenance_window import OneTimeMaintenanceWindow
from instana_client.models.opsgenie_integration import OpsgenieIntegration
from instana_client.models.order import Order
from instana_client.models.pagerduty_integration import PagerdutyIntegration
from instana_client.models.paginated_result import PaginatedResult
from instana_client.models.pagination import Pagination
from instana_client.models.parameter import Parameter
from instana_client.models.parameter_value import ParameterValue
from instana_client.models.path_parameter_http_path_segment_matching_rule import PathParameterHttpPathSegmentMatchingRule
from instana_client.models.physical_context import PhysicalContext
from instana_client.models.plugin_result import PluginResult
from instana_client.models.policy import Policy
from instana_client.models.policy_runnable import PolicyRunnable
from instana_client.models.post_snapshots_result import PostSnapshotsResult
from instana_client.models.problem import Problem
from instana_client.models.prometheus_webhook_integration import PrometheusWebhookIntegration
from instana_client.models.recurrent_maintenance_window import RecurrentMaintenanceWindow
from instana_client.models.release import Release
from instana_client.models.release_scope import ReleaseScope
from instana_client.models.release_with_metadata import ReleaseWithMetadata
from instana_client.models.rolling_time_window import RollingTimeWindow
from instana_client.models.rule_input import RuleInput
from instana_client.models.rule_with_threshold_application_alert_rule import RuleWithThresholdApplicationAlertRule
from instana_client.models.rule_with_threshold_infra_alert_rule import RuleWithThresholdInfraAlertRule
from instana_client.models.rule_with_threshold_log_alert_rule import RuleWithThresholdLogAlertRule
from instana_client.models.rule_with_threshold_mobile_app_alert_rule import RuleWithThresholdMobileAppAlertRule
from instana_client.models.rule_with_threshold_website_alert_rule import RuleWithThresholdWebsiteAlertRule
from instana_client.models.run_configuration import RunConfiguration
from instana_client.models.ssl_certificate_configuration import SSLCertificateConfiguration
from instana_client.models.salesforce_integration import SalesforceIntegration
from instana_client.models.scope_binding import ScopeBinding
from instana_client.models.search_field_result import SearchFieldResult
from instana_client.models.service import Service
from instana_client.models.service_config import ServiceConfig
from instana_client.models.service_event_result import ServiceEventResult
from instana_client.models.service_item import ServiceItem
from instana_client.models.service_level_indicator import ServiceLevelIndicator
from instana_client.models.service_level_objective_alert_rule import ServiceLevelObjectiveAlertRule
from instana_client.models.service_level_objective_configuration import ServiceLevelObjectiveConfiguration
from instana_client.models.service_levels_alert_config import ServiceLevelsAlertConfig
from instana_client.models.service_levels_alert_rule import ServiceLevelsAlertRule
from instana_client.models.service_levels_burn_rate_time_windows import ServiceLevelsBurnRateTimeWindows
from instana_client.models.service_levels_time_threshold import ServiceLevelsTimeThreshold
from instana_client.models.service_levelse_alert_config_with_metadata import ServiceLevelseAlertConfigWithMetadata
from instana_client.models.service_map import ServiceMap
from instana_client.models.service_map_connection import ServiceMapConnection
from instana_client.models.service_matching_rule import ServiceMatchingRule
from instana_client.models.service_metric_result import ServiceMetricResult
from instana_client.models.service_node import ServiceNode
from instana_client.models.service_now_enhanced_integration import ServiceNowEnhancedIntegration
from instana_client.models.service_now_integration import ServiceNowIntegration
from instana_client.models.service_result import ServiceResult
from instana_client.models.service_scope import ServiceScope
from instana_client.models.service_scope_with_metadata import ServiceScopeWithMetadata
from instana_client.models.service_scoped_to import ServiceScopedTo
from instana_client.models.service_scoped_to_with_metadata import ServiceScopedToWithMetadata
from instana_client.models.service_simple import ServiceSimple
from instana_client.models.session_settings import SessionSettings
from instana_client.models.slack_integration import SlackIntegration
from instana_client.models.sli_configuration import SliConfiguration
from instana_client.models.sli_configuration_with_last_updated import SliConfigurationWithLastUpdated
from instana_client.models.sli_entity import SliEntity
from instana_client.models.sli_report import SliReport
from instana_client.models.slo_entity import SloEntity
from instana_client.models.slo_report import SloReport
from instana_client.models.slowness_application_alert_rule import SlownessApplicationAlertRule
from instana_client.models.slowness_website_alert_rule import SlownessWebsiteAlertRule
from instana_client.models.snapshot_item import SnapshotItem
from instana_client.models.snapshot_preview import SnapshotPreview
from instana_client.models.snapshot_result import SnapshotResult
from instana_client.models.software_user import SoftwareUser
from instana_client.models.software_version import SoftwareVersion
from instana_client.models.source_map_file_blob import SourceMapFileBlob
from instana_client.models.source_map_file_meta import SourceMapFileMeta
from instana_client.models.source_map_upload_config import SourceMapUploadConfig
from instana_client.models.span import Span
from instana_client.models.span_excerpt import SpanExcerpt
from instana_client.models.span_relation import SpanRelation
from instana_client.models.specific_js_errors_website_alert_rule import SpecificJsErrorsWebsiteAlertRule
from instana_client.models.splunk_integration import SplunkIntegration
from instana_client.models.stack_trace_item import StackTraceItem
from instana_client.models.stack_trace_line import StackTraceLine
from instana_client.models.static_baseline_threshold_rule import StaticBaselineThresholdRule
from instana_client.models.static_string_field import StaticStringField
from instana_client.models.static_threshold import StaticThreshold
from instana_client.models.static_threshold_rule import StaticThresholdRule
from instana_client.models.status_code_application_alert_rule import StatusCodeApplicationAlertRule
from instana_client.models.status_code_mobile_app_alert_rule import StatusCodeMobileAppAlertRule
from instana_client.models.status_code_website_alert_rule import StatusCodeWebsiteAlertRule
from instana_client.models.synthetic_alert_config import SyntheticAlertConfig
from instana_client.models.synthetic_alert_config_with_metadata import SyntheticAlertConfigWithMetadata
from instana_client.models.synthetic_alert_rule import SyntheticAlertRule
from instana_client.models.synthetic_call_config import SyntheticCallConfig
from instana_client.models.synthetic_call_rule import SyntheticCallRule
from instana_client.models.synthetic_call_with_defaults_config import SyntheticCallWithDefaultsConfig
from instana_client.models.synthetic_credential import SyntheticCredential
from instana_client.models.synthetic_datacenter import SyntheticDatacenter
from instana_client.models.synthetic_datacenter_configuration import SyntheticDatacenterConfiguration
from instana_client.models.synthetic_geo_point import SyntheticGeoPoint
from instana_client.models.synthetic_location import SyntheticLocation
from instana_client.models.synthetic_location_configuration import SyntheticLocationConfiguration
from instana_client.models.synthetic_metric_configuration import SyntheticMetricConfiguration
from instana_client.models.synthetic_metric_tag_group import SyntheticMetricTagGroup
from instana_client.models.synthetic_playback_capabilities import SyntheticPlaybackCapabilities
from instana_client.models.synthetic_slo_entity import SyntheticSloEntity
from instana_client.models.synthetic_test import SyntheticTest
from instana_client.models.synthetic_time_threshold import SyntheticTimeThreshold
from instana_client.models.synthetic_type_configuration import SyntheticTypeConfiguration
from instana_client.models.synthetics_event_result import SyntheticsEventResult
from instana_client.models.system_rule import SystemRule
from instana_client.models.system_rule_label import SystemRuleLabel
from instana_client.models.tag import Tag
from instana_client.models.tag_catalog import TagCatalog
from instana_client.models.tag_filter import TagFilter
from instana_client.models.tag_filter_expression import TagFilterExpression
from instana_client.models.tag_filter_expression_element import TagFilterExpressionElement
from instana_client.models.tag_matcher_dto import TagMatcherDTO
from instana_client.models.tag_tree_level import TagTreeLevel
from instana_client.models.tag_tree_node import TagTreeNode
from instana_client.models.tag_tree_tag import TagTreeTag
from instana_client.models.test_common_properties import TestCommonProperties
from instana_client.models.test_result import TestResult
from instana_client.models.test_result_common_properties import TestResultCommonProperties
from instana_client.models.test_result_detail_data import TestResultDetailData
from instana_client.models.test_result_item import TestResultItem
from instana_client.models.test_result_list_item import TestResultListItem
from instana_client.models.test_result_list_result import TestResultListResult
from instana_client.models.test_result_metadata import TestResultMetadata
from instana_client.models.test_result_subtransaction import TestResultSubtransaction
from instana_client.models.threshold import Threshold
from instana_client.models.threshold_config_rule import ThresholdConfigRule
from instana_client.models.threshold_rule import ThresholdRule
from instana_client.models.throughput_application_alert_rule import ThroughputApplicationAlertRule
from instana_client.models.throughput_mobile_app_alert_rule import ThroughputMobileAppAlertRule
from instana_client.models.throughput_website_alert_rule import ThroughputWebsiteAlertRule
from instana_client.models.time_frame import TimeFrame
from instana_client.models.time_window import TimeWindow
from instana_client.models.topology import Topology
from instana_client.models.trace import Trace
from instana_client.models.trace_activity_tree_node_details import TraceActivityTreeNodeDetails
from instana_client.models.trace_download_result import TraceDownloadResult
from instana_client.models.trace_groups_item import TraceGroupsItem
from instana_client.models.trace_groups_result import TraceGroupsResult
from instana_client.models.trace_impact_application_time_threshold import TraceImpactApplicationTimeThreshold
from instana_client.models.trace_item import TraceItem
from instana_client.models.trace_result import TraceResult
from instana_client.models.traffic_blueprint_indicator import TrafficBlueprintIndicator
from instana_client.models.trigger import Trigger
from instana_client.models.type_configuration import TypeConfiguration
from instana_client.models.unsupported_http_path_segment_matching_rule import UnsupportedHttpPathSegmentMatchingRule
from instana_client.models.updated_business_perspective_config import UpdatedBusinessPerspectiveConfig
from instana_client.models.usage_result import UsageResult
from instana_client.models.usage_result_items import UsageResultItems
from instana_client.models.user_basic_result import UserBasicResult
from instana_client.models.user_impact_mobile_app_time_threshold import UserImpactMobileAppTimeThreshold
from instana_client.models.user_impact_website_time_threshold import UserImpactWebsiteTimeThreshold
from instana_client.models.user_result import UserResult
from instana_client.models.users_result import UsersResult
from instana_client.models.validated_alerting_channel_input_info import ValidatedAlertingChannelInputInfo
from instana_client.models.validated_alerting_configuration import ValidatedAlertingConfiguration
from instana_client.models.validated_maintenance_config_v2_with_state_and_occurrence import ValidatedMaintenanceConfigV2WithStateAndOccurrence
from instana_client.models.validated_maintenance_config_with_status import ValidatedMaintenanceConfigWithStatus
from instana_client.models.victor_ops_integration import VictorOpsIntegration
from instana_client.models.violations_in_period_application_time_threshold import ViolationsInPeriodApplicationTimeThreshold
from instana_client.models.violations_in_period_mobile_app_time_threshold import ViolationsInPeriodMobileAppTimeThreshold
from instana_client.models.violations_in_period_website_time_threshold import ViolationsInPeriodWebsiteTimeThreshold
from instana_client.models.violations_in_sequence_application_time_threshold import ViolationsInSequenceApplicationTimeThreshold
from instana_client.models.violations_in_sequence_infra_time_threshold import ViolationsInSequenceInfraTimeThreshold
from instana_client.models.violations_in_sequence_log_time_threshold import ViolationsInSequenceLogTimeThreshold
from instana_client.models.violations_in_sequence_mobile_app_time_threshold import ViolationsInSequenceMobileAppTimeThreshold
from instana_client.models.violations_in_sequence_synthetic_time_threshold import ViolationsInSequenceSyntheticTimeThreshold
from instana_client.models.violations_in_sequence_website_time_threshold import ViolationsInSequenceWebsiteTimeThreshold
from instana_client.models.watson_ai_ops_webhook_integration import WatsonAIOpsWebhookIntegration
from instana_client.models.webex_teams_webhook_integration import WebexTeamsWebhookIntegration
from instana_client.models.webhook_integration import WebhookIntegration
from instana_client.models.webpage_action_configuration import WebpageActionConfiguration
from instana_client.models.webpage_script_configuration import WebpageScriptConfiguration
from instana_client.models.website import Website
from instana_client.models.website_alert_config import WebsiteAlertConfig
from instana_client.models.website_alert_config_with_metadata import WebsiteAlertConfigWithMetadata
from instana_client.models.website_alert_rule import WebsiteAlertRule
from instana_client.models.website_apdex_entity import WebsiteApdexEntity
from instana_client.models.website_beacon_groups_item import WebsiteBeaconGroupsItem
from instana_client.models.website_beacon_groups_result import WebsiteBeaconGroupsResult
from instana_client.models.website_beacon_result import WebsiteBeaconResult
from instana_client.models.website_beacon_tag_group import WebsiteBeaconTagGroup
from instana_client.models.website_beacons_item import WebsiteBeaconsItem
from instana_client.models.website_event_based_sli_entity import WebsiteEventBasedSliEntity
from instana_client.models.website_event_result import WebsiteEventResult
from instana_client.models.website_metric_result import WebsiteMetricResult
from instana_client.models.website_monitoring_beacon import WebsiteMonitoringBeacon
from instana_client.models.website_monitoring_metric_description import WebsiteMonitoringMetricDescription
from instana_client.models.website_monitoring_metrics_configuration import WebsiteMonitoringMetricsConfiguration
from instana_client.models.website_slo_entity import WebsiteSloEntity
from instana_client.models.website_time_based_sli_entity import WebsiteTimeBasedSliEntity
from instana_client.models.website_time_threshold import WebsiteTimeThreshold
from instana_client.models.widget import Widget
from instana_client.models.with_metadata import WithMetadata
from instana_client.models.with_resolved_name import WithResolvedName
from instana_client.models.z_chat_ops_integration import ZChatOpsIntegration
